diff a/src/jdk.hotspot.agent/share/classes/sun/jvm/hotspot/debugger/DebuggerBase.java b/src/jdk.hotspot.agent/share/classes/sun/jvm/hotspot/debugger/DebuggerBase.java
--- a/src/jdk.hotspot.agent/share/classes/sun/jvm/hotspot/debugger/DebuggerBase.java
+++ b/src/jdk.hotspot.agent/share/classes/sun/jvm/hotspot/debugger/DebuggerBase.java
@@ -399,11 +399,11 @@
     throws UnmappedAddressException, UnalignedAddressException {
     long value;
     if (VM.getVM().isCompactObjectHeadersEnabled()) {
       // With compact headers, the compressed Klass* is currently read from the mark
       // word. We need to load the whole mark, and shift the upper parts.
-      value = readCInteger(address, machDesc.getAddressSize(), true);
+      value = readCInteger(address, jintSize, true);
       value = value >>> Mark.getKlassShift();
     } else {
       value = readCInteger(address, getKlassPtrSize(), true);
     }
     if (value != 0) {
